/*****************************************************************************
 UNIVERSIDAD DE ZARAGOZA
 DEPARTAMENTO DE INFORMATICA E INGENIERIA DE SISTEMAS
 AREA DE LENGUAJES Y SISTEMAS INFORMATICOS
******************************************************************************
******************************************************************************
 Fichero     :  clases.h
 Asignatura  :  Vision por Computador
******************************************************************************/

/*****************************************************************************
                              I N C L U D E S
******************************************************************************/

/*****************************************************************************
                            C O N S T A N T E S  
******************************************************************************/

#define MAXCLASES       100
#define MAXMUESTRAS     100
#define MAXDESCRIPTORES 20

/*****************************************************************************
                          D E F I N I C I O N E S
******************************************************************************/

/* registro para almacenar la informacion de un clase */

typedef struct
        {
	   double muestra[MAXMUESTRAS];
	   double media;
	   double varianza;
	} DESCRIPTOR;

typedef struct
        {
           char nombre[100];
	   int muestras;
	   DESCRIPTOR descriptor[MAXDESCRIPTORES];
        } CLASE; 

typedef struct
	{
	   int clases;
	   CLASE clase[MAXCLASES];
        } CLASES;


/* Variable donde se almacena la informacion de los clases conocidos */

CLASES clases;

/*****************************************************************************
                                M A C R O S
******************************************************************************/

#define NCLASES               (clases.clases)
#define NOMBRE(o)             (clases.clase[o].nombre)
#define MUESTRAS(o)           (clases.clase[o].muestras)
#define MUESTRA(o,p,m)        (clases.clase[o].descriptor[p].muestra[m])
#define MEDIA(o,p)            (clases.clase[o].descriptor[p].media)
#define VARIANZA(o,p)         (clases.clase[o].descriptor[p].varianza)

/*****************************************************************************
                              F U N C I O N E S
******************************************************************************/

void leer_clases (int ndescriptores);
void escribir_clases (int ndescriptores);
int buscar_clase (char *nombre);
int crear_clase (char *nombre);
void anadir_muestra (int clase, double p[], int ndescriptores);
void actualizar_medias_y_varianzas (int clase, int ndescriptores);
void ordenar_clases ();
void ordenar_clases_por_descriptor (int p);
